/*
    Copyright 2011 Tianjun Liao Marco A. Montes de Oca, Dogan Aydin, Thomas Stuetzle and Marco Dorigo (IACOr-LS)
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle (IPSOLS)
    Code structure is developed by Marco A. Montes de Oca.

    This file is part of IACOr-LS.

    IACOr-LS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IACOr-LS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IACOr-LS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ACO_H
#define ACO_H

#include "configuration.h"
#include "swarm.h"
#include "problem.h"

class ACO {
	    
      protected:
	Configuration* config;	
	Swarm* s;
	Problem* p;	
	
      public:
	ACO(Configuration* config, Swarm* swarm, Problem* problem);
 	virtual ~ACO();

	virtual bool notDone() = 0;		

	double limitVelocity(double vel);
	double clampPosition(double candidate);	
	double clampPositionVelocity(double candidate,double* velocity);	
	double reboundPosition(double candidate,double* velocity);
	double acorboundPosition(double candidate);
	virtual void run() = 0;		
			
	void printSolution();
		
};

#endif

