/*
    Copyright 2011 Tianjun Liao Marco A. Montes de Oca, Dogan Aydin, Thomas Stuetzle and Marco Dorigo (IACOr-LS)
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle (IPSOLS)
    Code structure is developed by Marco A. Montes de Oca.

    This file is part of IACOr-LS.

    IACOr-LS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IACOr-LS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IACOr-LS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LOCALSEARCH_H_INCLUDED
#define LOCALSEARCH_H_INCLUDED

#include "problem.h"
#include "configuration.h"
#include "particle.h"
#include "powell.h"

class LocalSearch {

    public:
        LocalSearch(Problem* problem, Configuration* config);
        ~LocalSearch();


	void apply(Particle * p, double stepSize);
	void applymtsls1(Particle * part, double SR);
	int mtsls1(double xk[],	/* Initial starting point */
	           double s, Particle * partlocal,
	           obj_func fun, 		/* Error function to evaluate */
	           long double * fun_data        /* additional information if required, if not pass NULL*/);				/* Size of initial search area */


    private:
        Problem* problem;
        Configuration* config;

        obj_func getProblemFunc(int funcID); // gets the function name for evaluation


};

#endif // LOCALSEARCH_H_INCLUDED
