/*
    Copyright 2011 Tianjun Liao Marco A. Montes de Oca, Dogan Aydin, Thomas Stuetzle and Marco Dorigo (IACOr-LS)
    Copyright 2010 Marco A. Montes de Oca, Dogan Aydin and Thomas Stuetzle (IPSOLS)
    Code structure is developed by Marco A. Montes de Oca.

    This file is part of IACOr-LS.

    IACOr-LS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    IACOr-LS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with IACOr-LS.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef IACO_H
#define IACO_H

#include "configuration.h"
#include "swarm.h"
#include "problem.h"
#include "ACO.h"
#include "localSearch.h"

class IncrementalACO: public ACO{

      private:
	double iwMin, iwMax, coefMin, coefMax, velMin, velMax;
	LocalSearch* ls;
	
      public:

	 IncrementalACO(Configuration* config, Swarm* swarm, Problem* problem);
        ~IncrementalACO();

        bool notDone();
        void run();

        void applyLocalSearch(LocalSearch* ls, Particle * p);

        //acor
        void acorexploit();
        void acorexplore();
        void acorselectway();

};

#endif

